package de.popforge.cubicvr.gui
{
	import flash.display.Bitmap;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	public class Cursor extends Bitmap
	{
		[Embed(source='/assets/assets.swf#cursor_orbit')]  public var COrbit: Class;
		[Embed(source='/assets/assets.swf#cursor_move')]   public var CMove: Class;
		[Embed(source='/assets/assets.swf#cursor_move_0')] public var CMove0: Class;
		[Embed(source='/assets/assets.swf#cursor_move_1')] public var CMove1: Class;
		[Embed(source='/assets/assets.swf#cursor_move_2')] public var CMove2: Class;
		[Embed(source='/assets/assets.swf#cursor_move_3')] public var CMove3: Class;
		[Embed(source='/assets/assets.swf#cursor_move_4')] public var CMove4: Class;
		[Embed(source='/assets/assets.swf#cursor_move_5')] public var CMove5: Class;
		[Embed(source='/assets/assets.swf#cursor_move_6')] public var CMove6: Class;
		[Embed(source='/assets/assets.swf#cursor_move_7')] public var CMove7: Class;
		[Embed(source='/assets/assets.swf#cursor_node_link')] public var CLink: Class;
		
		private var delta: Point;
		
		public function Cursor()
		{
			delta = new Point();
		}
		
		public function show( name: String ): void
		{
			Mouse.hide();
			
			switch( name )
			{
				case 'orbit':
				
					bitmapData = new COrbit().bitmapData;
					delta.x = -4;
					delta.y = -4;
					break;
					
				case 'move':
				
					bitmapData = new CMove().bitmapData;
					delta.x = -7;
					delta.y = -7;
					break;
					
				case 'cursor_move_0':
				
					bitmapData = new CMove0().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_1':
				
					bitmapData = new CMove1().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_2':
				
					bitmapData = new CMove2().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_3':
				
					bitmapData = new CMove3().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_4':
				
					bitmapData = new CMove4().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_5':
				
					bitmapData = new CMove5().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_6':
				
					bitmapData = new CMove6().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'cursor_move_7':
				
					bitmapData = new CMove7().bitmapData;
					delta.x = -10;
					delta.y = -10;
					break;
					
				case 'link':
				
					bitmapData = new CLink().bitmapData;
					delta.x = -6;
					delta.y = 0;
					break;
					
				case null:
				
					Mouse.show();
					stage.removeEventListener( MouseEvent.MOUSE_MOVE, onMouseMove );
					bitmapData = null;
					return;
			}
			
			stage.addEventListener( MouseEvent.MOUSE_MOVE, onMouseMove );
			
			onMouseMove( null );
		}
		
		private function onMouseMove( event: MouseEvent ): void
		{
			x = parent.mouseX + delta.x;
			y = parent.mouseY + delta.y;
		}
	}
}