package de.popforge.cubicvr.config
{
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	
	public class Configuration
	{
		public var onComplete: Function;
		
		private var xml: XML;
		private var loader: URLLoader;
		
		public function Configuration()
		{
		}
		
		public function loadXML( url: String ): void
		{
			loader = new URLLoader();
			loader.addEventListener( Event.COMPLETE, onXMLLoad );
			loader.load( new URLRequest( url ) );
		}
		
		public function getXML(): XML
		{
			return xml;
		}
		
		private function onXMLLoad( event: Event ): void
		{
			xml = new XML( loader.data );
			
			var cubeList: XMLList = xml.child( "vr" );
			
			//trace( xml.vr.cube.(@name == "next" ) );

			loader.removeEventListener( Event.COMPLETE, onXMLLoad );
			
			onComplete();
		}
	}
}