package de.popforge.cubicvr.smart3d
{
	public class Vertex
	{
		//-- world coordinates
		public var wx: Number;
		public var wy: Number;
		public var wz: Number;
		
		//-- transformed coordinates
		public var tx: Number;
		public var ty: Number;
		public var tz: Number;
		
		//-- texture coordinates
		public var u: Number;
		public var v: Number;
		
		//-- screen coordinates (including depth: sz)
		public var sx: Number;
		public var sy: Number;
		public var sz: Number;
		
		//-- constructor
		public function Vertex( x: Number, y: Number, z: Number, u: Number, v: Number )
		{
			wx = tx = x;
			wy = ty = y;
			wz = tz = z;

			this.u = u;
			this.v = v;
		}
	}
}